---------------------------------------------
-- Mud
---------------------------------------------

-- Light plant field
AddRoom("LightPlantField", {
    colour={r=0.7,g=0.5,b=0.3,a=0.9},
    value = GROUND.MUD,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .2,
        distributeprefabs=
        {
            flower_cave = 1.2,
            flower_cave_double = 0.6,
            flower_cave_triple = 0.6,

            stalagmite_tall=0.05,
            stalagmite_tall_med=0.05,
            stalagmite_tall_low=0.1,
            pillar_cave = 0.01,

            cave_fern = 0.1,

            slurtlehole = 0.01,

            slurper = 0.001,
        },
    }
})

-- Worm light field
AddRoom("WormPlantField", {
    colour={r=0.7,g=0.5,b=0.3,a=0.9},
    value = GROUND.MUD,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .15,
        distributeprefabs=
        {
            flower_cave = 0.5,
            flower_cave_double = 0.1,
            flower_cave_triple = 0.1,

            stalagmite_tall=0.05,
            stalagmite_tall_med=0.05,
            stalagmite_tall_low=0.1,
            pillar_cave = 0.01,

            cave_fern = 0.1,

            slurtlehole = 0.01,

            slurper = 0.001,
        },
    }
})

-- Fern gully
AddRoom("FernGully", {
    colour={r=0.7,g=0.5,b=0.3,a=0.9},
    value = GROUND.MUD,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .25,
        distributeprefabs=
        {
            flower_cave = 0.2,
            flower_cave_double = 0.1,
            flower_cave_triple = 0.1,

            stalagmite_tall=0.5,
            stalagmite_tall_med=0.3,
            stalagmite_tall_low=0.2,
            pillar_cave = 0.1,

            cave_fern = 2.0,

            slurtlehole = 0.01,

            slurper = 0.001,
        },
    }
})

-- Slurtle plains
AddRoom("SlurtlePlains", {
    colour={r=0.7,g=0.5,b=0.3,a=0.9},
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .20,
        distributeprefabs=
        {
            flower_cave = 0.2,
            flower_cave_double = 0.1,
            flower_cave_triple = 0.1,

            stalagmite_tall=1.5,
            stalagmite_tall_med=0.5,
            stalagmite_tall_low=0.5,
            pillar_cave = 0.1,

            cave_fern = 0.5,
         

            slurtlehole = 0.5,
        },
    }
})

-- Rabbit hermit
AddRoom("MudWithRabbit", {
    colour={r=0.7,g=0.5,b=0.3,a=0.9},
    value = GROUND.MUD,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .15,
        distributeprefabs=
        {
            flower_cave = 0.5,
            flower_cave_double = 0.3,
            flower_cave_triple = 0.2,

            stalagmite_tall=0.5,
            stalagmite_tall_med=0.3,
            stalagmite_tall_low=0.2,
            pillar_cave = 0.1,

            cave_fern = 1.0,

            slurper = 0.001,
        },
    }
})

AddRoom("BGMud", {
    colour={r=0.7,g=0.5,b=0.3,a=0.9},
    value = GROUND.MUD,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .15,
        distributeprefabs=
        {
            flower_cave = 0.1,

            stalagmite_tall=1.5,
            stalagmite_tall_med=1.0,
            stalagmite_tall_low=0.5,
            pillar_cave = 0.15,
		pillar_stalactite = 0.15,

            cave_fern = 1.0,

            slurtlehole = 0.05,

            slurper = 0.001,
        },
    }
})

---------------------------------------------
-- Rocky
---------------------------------------------

-- Slurtle Canyon
AddRoom("SlurtleCanyon", {
    colour={r=0.7,g=0.7,b=0.7,a=0.9},
    value = GROUND.CAVE_NOISE,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .15,
        distributeprefabs=
        {
            rock_flintless = 1.0,
            rock_flintless_med = 1.0,
            rock_flintless_low = 1.0,
            pillar_cave = 1.2,

            slurtlehole = 0.5,

            fissure = 0.01,
        },
    }
})

-- Bats and Slurtles
AddRoom("BatsAndSlurtles", {
    colour={r=0.7,g=0.7,b=0.7,a=0.9},
    value = GROUND.CAVE_NOISE,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .15,
        distributeprefabs=
        {
            rock_flintless = 1.0,
            rock_flintless_med = 1.0,
            rock_flintless_low = 1.0,
            pillar_cave = 0.2,

            stalagmite_tall=0.5,
            stalagmite_tall_med=0.2,
            stalagmite_tall_low=0.2,
            pillar_cave = 0.1,

            slurtlehole = 0.5,
            bat = 0.1,

            fissure = 0.01,
        },
    }
})

-- Rocky Plains
AddRoom("RockyPlains", {
    colour={r=0.7,g=0.7,b=0.7,a=0.9},
    value = GROUND.CAVE_NOISE,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .10,
        distributeprefabs=
        {
            rock_flintless = 1.0,
            rock_flintless_med = 1.0,
            rock_flintless_low = 1.0,
            pillar_cave = 0.2,

            rocky = 0.5,
            goldnugget=.05,
            rocks=.1,
            flint=0.05,

            slurtlehole = 0.05,

            fissure = 0.01,
        },
    }
})

-- Rocky Hatching Grounds
AddRoom("RockyHatchingGrounds", {
    colour={r=0.7,g=0.7,b=0.7,a=0.9},
    value = GROUND.CAVE_NOISE,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .25,
        distributeprefabs=
        {
            rock_flintless = 1.0,
            rock_flintless_med = 1.0,
            rock_flintless_low = 1.0,
            pillar_cave = 0.2,

            rocky = 1.0,
            goldnugget=.05,
            rocks=.1,
            flint=0.05,

            slurtlehole = 0.05,

            fissure = 0.01,
        },
    }
})

-- Bats and Rocky
AddRoom("BatsAndRocky", {
    colour={r=0.7,g=0.7,b=0.7,a=0.9},
    value = GROUND.CAVE_NOISE,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .20,
        distributeprefabs=
        {
            rock_flintless = 1.0,
            rock_flintless_med = 1.0,
            rock_flintless_low = 1.0,
            pillar_cave = 0.8,

            stalagmite_tall=0.5,
            stalagmite_tall_med=0.2,
            stalagmite_tall_low=0.2,
            pillar_cave = 0.1,

            rocky = 0.5,
            goldnugget=.05,
            rocks=.1,
            flint=0.05,

            slurtlehole = 0.05,
            bat = 0.10,

            fissure = 0.01,
        },
    }
})

AddRoom("BGRockyCave", {
    colour={r=0.7,g=0.7,b=0.7,a=0.9},
    value = GROUND.CAVE_NOISE,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .10,
        distributeprefabs=
        {
            rock_flintless = 1.0,
            rock_flintless_med = 1.0,
            rock_flintless_low = 1.0,
            pillar_cave = 0.2,

            slurtlehole = 0.05,

            fissure = 0.01,
        },
    }
})
------------------------------------------------------------------------------------
-- Caves -----------------------------------------------------------------------
------------------------------------------------------------------------------------
-- Blue mush forest
AddRoom("BlueMushForest", {
    colour={r=0.1,g=0.1,b=0.8,a=0.9},
    value = GROUND.FUNGUS,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .6,
        distributeprefabs=
        {
            mushtree_tall = 5.0,
            blue_mushroom = 0.5,
            flower_cave = 0.1,
            flower_cave_double = 0.05,
            flower_cave_triple = 0.05,

            bat = 0.005,
            dropperweb = 0.015,

            slurper = 0.001,
        },
    }
})

-- Blue light meadow
AddRoom("BlueMushMeadow", {
    colour={r=0.1,g=0.1,b=0.8,a=0.9},
    value = GROUND.FUNGUS,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .3,
        distributeprefabs=
        {
            mushtree_tall = 1.0,
            blue_mushroom = 2.5,
            flower_cave = 0.1,
            flower_cave_double = 0.05,
            flower_cave_triple = 0.05,

            bat = 0.005,
            dropperweb = 0.015,

            slurper = 0.001,
        },
    }
})

-- Dropper forest
AddRoom("BlueSpiderForest", {
    colour={r=0.1,g=0.1,b=0.8,a=0.9},
    value = GROUND.FUNGUS,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .4,
        distributeprefabs=
        {
            mushtree_tall = 3.0,
            blue_mushroom = 2.5,
            flower_cave = 0.1,
            flower_cave_double = 0.05,
            flower_cave_triple = 0.05,

            dropperweb = 0.1,
            boneshard = 0.2,
            houndbone = 0.2,

            slurper = 0.001,
        },
    }
})

-- Dropper desolation
AddRoom("DropperDesolation", {
    colour={r=0.1,g=0.1,b=0.8,a=0.9},
    value = GROUND.FUNGUS,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .2,
        distributeprefabs=
        {
            mushtree_tall = 2.0,
            blue_mushroom = 1.5,
            flower_cave = 0.1,
            flower_cave_double = 0.05,
            flower_cave_triple = 0.05,

            dropperweb = 1.5,
            boneshard = 0.4,
            houndbone = 1.6,

            slurper = 0.001,
        },
    }
})

AddRoom("BGBlueMush", {
    colour={r=0.1,g=0.1,b=0.8,a=0.9},
    value = GROUND.FUNGUS,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .6,
        distributeprefabs=
        {
            mushtree_tall = 6.0,
            blue_mushroom = 0.5,
            flower_cave = 0.1,
            flower_cave_double = 0.05,
            flower_cave_triple = 0.05,

            bat = 0.005,
            dropperweb = 0.015,

            slurper = 0.001,
        },
    }
})

-- Red mush forest
AddRoom("RedMushForest", {
    colour={r=0.8,g=0.1,b=0.1,a=0.9},
    value = GROUND.FUNGUSRED,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .3,
        distributeprefabs=
        {
            mushtree_medium = 6.0,
            red_mushroom = 0.5,
            flower_cave = 0.2,
            flower_cave_double = 0.1,
            flower_cave_triple = 0.1,

            stalagmite = 0.35,
            stalagmite_med = 0.1,
            stalagmite_low = 0.05,
            pillar_cave = 0.1,
            spiderhole = 0.05,

            slurper = 0.001,
        },
    }
})

-- Spider mush forest
AddRoom("RedSpiderForest", {
    colour={r=0.8,g=0.1,b=0.4,a=0.9},
    value = GROUND.FUNGUSRED,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .3,
        distributeprefabs=
        {
            mushtree_medium = 3.0,
            red_mushroom = 0.25,
            flower_cave = 0.2,
            flower_cave_double = 0.1,
            flower_cave_triple = 0.1,

            stalagmite = 1.0,
            stalagmite_med = 0.4,
            stalagmite_low = 0.1,
            pillar_cave = 0.2,
            spiderhole = 0.4,

            slurper = 0.001,
        },
    }
})

-- Pillar Red Mush Meadow
AddRoom("RedMushPillars", {
    colour={r=0.8,g=0.1,b=0.4,a=0.9},
    tags = {"ForceConnected"},
    value = GROUND.FUNGUSRED,
    contents =  {
        distributepercent = .15,
        distributeprefabs=
        {
            mushtree_medium = 2.0,
            red_mushroom = 1.5,
            flower_cave = 0.5,
            flower_cave_double = 0.2,
            flower_cave_triple = 0.2,

            stalagmite = 0.35,
            stalagmite_med = 0.1,
            stalagmite_low = 0.05,
            pillar_cave = 0.5,
            spiderhole = 0.01,

            slurper = 0.001,
        },
    }
})

-- Stalagmite Forest
AddRoom("StalagmiteForest", {
    colour={r=0.8,g=0.1,b=0.1,a=0.9},
    value = GROUND.FUNGUSRED,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .3,
        distributeprefabs=
        {
            mushtree_medium = 1.0,
            red_mushroom = 0.25,
            flower_cave = 0.2,
            flower_cave_double = 0.1,
            flower_cave_triple = 0.1,

            stalagmite = 2.5,
            stalagmite_med = 0.7,
            stalagmite_low = 0.3,
            pillar_cave = 1.0,
            spiderhole = 0.15,

            slurper = 0.001,
        },
    }
})

-- Spillagmite meadow
AddRoom("RedSpiderMeadow", {
    colour={r=0.8,g=0.1,b=0.1,a=0.9},
    value = GROUND.FUNGUSRED,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .15,
        distributeprefabs=
        {
            mushtree_medium = 0.5,
            red_mushroom = 0.25,
            flower_cave = 0.5,
            flower_cave_double = 0.2,
            flower_cave_triple = 0.2,

            stalagmite = 1.0,
            stalagmite_med = 0.4,
            stalagmite_low = 0.1,
            pillar_cave = 0.05,
            spiderhole = 0.45,

            slurper = 0.001,
        },
    }
})
AddRoom("BGRedMush", {
    colour={r=0.8,g=0.1,b=0.1,a=0.9},
    value = GROUND.FUNGUSRED,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .3,
        distributeprefabs=
        {
            mushtree_medium = 6.0,
            red_mushroom = 0.5,
            flower_cave = 0.2,
            flower_cave_double = 0.1,
            flower_cave_triple = 0.1,

            stalagmite = 0.1,
            stalagmite_med = 0.07,
            stalagmite_low = 0.03,
            pillar_cave = 0.05,
            spiderhole = 0.01,

            slurper = 0.001,
        },
    }
})


---------------------------------------------
-- Green Mush
-- Spring, plants, overworld
---------------------------------------------

-- Green mush forest
AddRoom("GreenMushForest", {
    colour={r=0.1,g=0.8,b=0.1,a=0.9},
    value = GROUND.FUNGUSGREEN,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .35,
        distributeprefabs=
        {
            mushtree_small = 6.0,
            green_mushroom = 0.5,
            flower_cave = 0.2,
            flower_cave_double = 0.1,
            flower_cave_triple = 0.1,

            rabbithouse = 0.02,

            cave_fern = 2.5,

            slurper = 0.001,
        },
    }
})

-- Mush and ponds -- overworld ponds, not cave ponds!
AddRoom("GreenMushPonds", {
    colour={r=0.1,g=0.8,b=0.3,a=0.9},
    value = GROUND.FUNGUSGREEN,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .3,
        distributeprefabs=
        {
            mushtree_small = 3.0,
            green_mushroom = 0.5,
            flower_cave = 0.2,
            flower_cave_double = 0.1,
            flower_cave_triple = 0.1,

            pond = 0.5,

            cave_fern = 2.5,

            slurper = 0.001,
            rabbithouse = 0.005,
        },
    }
})

-- Greenmush Sinkhole
AddRoom("GreenMushTrees", {
    colour={r=0.1,g=0.8,b=0.3,a=0.9},
    value = GROUND.FUNGUSGREEN,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .2,
        distributeprefabs=
        {
            mushtree_small = 1.0,
            green_mushroom = 0.5,
            flower_cave = 0.2,
            flower_cave_double = 0.1,
            flower_cave_triple = 0.1,

            --cavelight = 0.1,

            evergreen = 0.1,
            grass = 0.1,
            sapling = 0.1,
            berrybush = 0.05,

            cave_fern = 3.5,

            slurper = 0.001,
            rabbithouse = 0.005,
        },
    }
})

-- Mush and Ferns meadow
AddRoom("GreenMushMeadow", {
    colour={r=0.1,g=0.8,b=0.3,a=0.9},
    value = GROUND.FUNGUSGREEN,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .25,
        distributeprefabs=
        {
            mushtree_small = 2.0,
            green_mushroom = 2.0,
            flower_cave = 0.5,
            flower_cave_double = 0.2,
            flower_cave_triple = 0.2,

            cave_fern = 3.5,

            slurper = 0.001,
            rabbithouse = 0.005,
        },
    }
})

-- Mushy Rabbit Hangout
AddRoom("GreenMushRabbits", {
    colour={r=0.1,g=0.8,b=0.3,a=0.9},
    value = GROUND.FUNGUSGREEN,
    tags = {"ForceConnected"},
    contents =  {
        countstaticlayouts={
            ["RabbitTown"]=1,
        },
        distributepercent = .2,
        distributeprefabs=
        {
            mushtree_small = 2.0,
            green_mushroom = 0.5,
            flower_cave = 0.2,
            flower_cave_double = 0.1,
            flower_cave_triple = 0.1,

            --cavelight = 0.1,

            evergreen = 0.1,
            grass = 0.1,
            sapling = 0.1,
            berrybush = 0.05,

            cave_fern = 3.5,

            slurper = 0.001,
            rabbithouse = 0.005,
        },
    }
})

-- Green Mush and Sinkhole Noise
AddRoom("GreenMushNoise", {
    colour={r=.36,g=.32,b=.38,a=.50},
    value = GROUND.FUNGUSGREEN,
    tags = {"ForceConnected"},
    custom_tiles={
        GeneratorFunction = RUNCA.GeneratorFunction,
        data = {iterations=8, seed_mode=CA_SEED_MODE.SEED_RANDOM, num_random_points=2,
            translate={
                {tile=GROUND.FUNGUSGREEN, items={"mushtree_small", "flower_cave", "cave_fern"}, item_count=20},
                {tile=GROUND.FUNGUSGREEN, items={"mushtree_small", "flower_cave", "cave_fern"}, item_count=20},
                {tile=GROUND.FUNGUSGREEN, items={"mushtree_small", "flower_cave", "cave_fern"}, item_count=20},
                {tile=GROUND.SINKHOLE, items={"evergreen", "grass", "sapling", "berrybush"}, item_count=20},
                {tile=GROUND.SINKHOLE, items={"evergreen", "grass", "sapling"}, item_count=20},
            },
        },
    },
    contents =  {
        distributepercent = .25,
        distributeprefabs=
        {
            mushtree_small = 2.0,
            green_mushroom = 2.0,
            flower_cave = 0.5,
            flower_cave_double = 0.2,
            flower_cave_triple = 0.2,

            cave_fern = 3.5,

            slurper = 0.001,
            rabbithouse = 0.005,
        },
    }
})

AddRoom("BGGreenMush", {
    colour={r=0.1,g=0.8,b=0.1,a=0.9},
    value = GROUND.FUNGUSGREEN,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .25,
        distributeprefabs=
        {
            mushtree_small = 6.0,
            green_mushroom = 0.5,
            flower_cave = 0.1,
            flower_cave_double = 0.1,
            flower_cave_triple = 0.1,

            rabbithouse = 0.02,

            cave_fern = 2.5,

            slurper = 0.001,
        },
    }
})


---------------------------------------------
-- Bat Caves
---------------------------------------------

-- Classic bat cave
AddRoom("BatCave", {
    colour={r=0.3,g=0.2,b=0.1,a=0.3},
    value = GROUND.CAVE,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .15,
        distributeprefabs=
        {
            bat = 1,
            guano = 0.27,
            goldnugget=.05,
            flint=0.05,
            stalagmite_tall=0.4,
            stalagmite_tall_med=0.4,
            stalagmite_tall_low=0.4,
            pillar_cave = 0.08,
            fissure = 0.05,
        }
    }
})

-- Very batty bat cave
AddRoom("BattyCave", {
    colour={r=0.3,g=0.2,b=0.1,a=0.3},
    value = GROUND.CAVE,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .25,
        distributeprefabs=
        {
            bat = 1,
            guano = 0.27,
            goldnugget=.05,
            flint=0.05,
            stalagmite_tall=0.4,
            stalagmite_tall_med=0.4,
            stalagmite_tall_low=0.4,
            pillar_cave = 0.08,
            fissure = 0.05,
        }
    }
})
-- Ferny bat cave
AddRoom("FernyBatCave", {
    colour={r=0.3,g=0.2,b=0.1,a=0.3},
    value = GROUND.CAVE,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .25,
        distributeprefabs=
        {
            cave_fern = 0.5,
            bat = 0.5,
            guano = 0.27,
            goldnugget=.05,
            flint=0.05,
            stalagmite_tall=0.1,
            stalagmite_tall_med=0.1,
            stalagmite_tall_low=0.1,
            pillar_cave = 0.08,
            fissure = 0.05,
        }
    }
})

AddRoom("BGBatCave", {
    colour={r=0.3,g=0.2,b=0.1,a=0.3},
    value = GROUND.CAVE,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .13,
        distributeprefabs=
        {
            bat = 0.5,
            stalagmite_tall=0.4,
            stalagmite_tall_med=0.4,
            stalagmite_tall_low=0.4,
            pillar_cave = 0.01,
            fissure = 0.05,
        }
    }
})


---------------------------------------------
-- Spillagmites
-- Spiders and pillars, a little bit of nightmare
---------------------------------------------

-- Spillagmite Forest
AddRoom("SpillagmiteForest", {
    colour={r=0.4,g=0.4,b=0.4,a=0.9},
    value = GROUND.UNDERROCK,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .35,
        distributeprefabs=
        {
            stalagmite = 0.35,
            stalagmite_med = 0.1,
            stalagmite_low = 0.05,
            pillar_cave = 0.1,
            pillar_stalactite = 0.1,
            spiderhole = 0.05,

            fissure = 0.01,
        },
    }
})

-- Dropper Canyon
AddRoom("DropperCanyon", {
    colour={r=0.4,g=0.4,b=0.4,a=0.9},
    value = GROUND.UNDERROCK,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
		countprefabs=
		{ cave_stairs = 1,
	},
        distributepercent = .35,
        distributeprefabs=
        {
            stalagmite = 0.35,
            stalagmite_med = 0.1,
            stalagmite_low = 0.05,
            pillar_cave = 0.2,
            pillar_stalactite = 0.2,
            dropperweb = 0.25,

            boneshard = 0.2,
            houndbone = 0.2,

            fissure = 0.01,
        },
    }
})

-- Stalagmites and Lights
AddRoom("StalagmitesAndLights", {
    colour={r=0.4,g=0.4,b=0.4,a=0.9},
    value = GROUND.UNDERROCK,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .15,
        distributeprefabs=
        {
            stalagmite = 0.35,
            stalagmite_med = 0.1,
            stalagmite_low = 0.05,
            pillar_cave = 0.1,
            pillar_stalactite = 0.1,
            spiderhole = 0.01,

            flower_cave = 0.1,

            fissure = 0.1,
            slurper = 0.001,
        },
    }
})

-- Spiders and Bats
AddRoom("SpidersAndBats", {
    colour={r=0.4,g=0.4,b=0.4,a=0.9},
    value = GROUND.UNDERROCK,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .15,
        distributeprefabs=
        {
            stalagmite = 0.35,
            stalagmite_med = 0.1,
            stalagmite_low = 0.05,
            pillar_cave = 0.1,
            pillar_stalactite = 0.1,
            spiderhole = 0.05,
            bat = 0.05,

            fissure = 0.01,
        },
    }
})

-- Thulecite debris
AddRoom("ThuleciteDebris", {
    colour={r=0.4,g=0.4,b=0.4,a=0.9},
    value = GROUND.UNDERROCK,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .15,
        distributeprefabs=
        {
            stalagmite = 0.35,
            stalagmite_med = 0.1,
            stalagmite_low = 0.05,
            pillar_cave = 0.1,
            pillar_stalactite = 0.1,
            spiderhole = 0.01,
            bat = 0.01,

            fissure = 0.1,
            thulecite = 0.01,
            thulecite_pieces = 0.05,
        },
    }
})

AddRoom("BGSpillagmite", {
    colour={r=0.4,g=0.4,b=0.4,a=0.9},
    value = GROUND.UNDERROCK,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .35,
        distributeprefabs=
        {
            stalagmite = 0.35,
            stalagmite_med = 0.1,
            stalagmite_low = 0.05,
            pillar_cave = 0.1,
            pillar_stalactite = 0.1,
            spiderhole = 0.05,

            fissure = 0.01,
        },
    }
})

---------------------------------------------
-- Rabbit Lair
---------------------------------------------

-- Loose village
AddRoom("RabbitArea", {
    colour={r=0.3,g=0.2,b=0.1,a=0.3},
    value = GROUND.SINKHOLE,
    type = NODE_TYPE.Room,
    --tags = {"ForceConnected"},
    contents =  {
        distributepercent = .2,
        distributeprefabs=
        {
            --cavelight = 0.01,
            flower_cave = 0.5,
            flower_cave_double = 0.1,
            flower_cave_triple = 0.05,
            carrot_planted = 1,
            rabbithouse = 0.21,
            cave_fern=0.5,
            fireflies = 0.01,

            red_mushroom = 0.1,
            green_mushroom = 0.1,
            blue_mushroom = 0.1,
        }
    }
})

-- Robust town
AddRoom("RabbitTown", {
    colour={r=0.3,g=0.2,b=0.3,a=0.9},
    value = GROUND.SINKHOLE,
    contents =  {
        countstaticlayouts={
            ["RabbitTown"]=1,
        },
        distributepercent = .2,
        distributeprefabs=
        {
            --cavelight = 0.025,
            flower_cave=0.75,
            carrot_planted = 1,
            cave_fern=0.75,
            rabbithouse = 0.51,
            fireflies = 0.01,
        }
    }
})

-- City
AddRoom("RabbitCity", {
    colour={r=0.3,g=0.2,b=0.5,a=0.9},
    value = GROUND.SINKHOLE,
    contents =  {
        countstaticlayouts={
            ["RabbitTown"]=2,
        },
        distributepercent = .15,
        distributeprefabs=
        {
            --cavelight = 0.025,
            flower_cave_double = 0.1,
            flower_cave_triple = 0.05,
            flower_cave=0.75,
            carrot_planted = 1,
            cave_fern=0.75,
            rabbithouse = 0.51,
            fireflies = 0.01,
        }
    }
})

-- Sinkhole gathering
AddRoom("RabbitSinkhole", {
    colour={r=.15,g=.18,b=.15,a=.50},
    value = GROUND.SINKHOLE,
    type = NODE_TYPE.Room,
    custom_tiles={
        GeneratorFunction = RUNCA.GeneratorFunction,
        data = {
            iterations=8,
            seed_mode=CA_SEED_MODE.SEED_CENTROID,
            num_random_points=1,
            translate={
                {tile = GROUND.GRASS, items = {"sapling","berrybush"},                          item_count = 5},
                {tile = GROUND.GRASS, items = {"grass", "berrybush", "rabbithouse"},            item_count = 10},
                {tile = GROUND.GRASS, items = {"grass", "sapling", "evergreen", "rabbithouse"}, item_count = 12},
                {tile = GROUND.GRASS, items = {"evergreen", "sapling", "rabbithouse"},          item_count = 10},
                {tile = GROUND.GRASS, items = {"not_used"},                                     item_count = 300},
            },
            centroid = {
                tile = GROUND.FOREST, items = {"--cavelight"},                                    item_count = 1
            },
        },
    },
    contents =  {
        distributepercent = .175,
        distributeprefabs =
        {
            --cavelight = 0.025,

            spiderden = .1,
            rabbithouse = 1,

            fireflies = 1,
            sapling = 15,
            evergreen = .25,
            berrybush = .5,
            blue_mushroom = .5,
            green_mushroom = .3,
            red_mushroom = .4,
            grass = .25,
            cave_fern = 20,
        },
    }
})

-- Spider incursion (overworld spiders)
AddRoom("SpiderIncursion", {
    colour={r=.10,g=.08,b=.05,a=.50},
    value = GROUND.SINKHOLE,
    type = NODE_TYPE.Room,
    custom_tiles={
        GeneratorFunction = RUNCA.GeneratorFunction,
        data = {
            iterations=3,
            seed_mode=CA_SEED_MODE.SEED_CENTROID,
            num_random_points=1,
            translate={
                {tile = GROUND.SINKHOLE, items = {"grass"},                                      item_count=3},
                {tile = GROUND.SINKHOLE, items = {"sapling","berrybush"},                        item_count=5},
                {tile = GROUND.GRASS,    items = {"grass", "berrybush", "spiderden"},            item_count=10},
                {tile = GROUND.GRASS,    items = {"grass", "sapling", "evergreen", "spiderden"}, item_count=12},
                {tile = GROUND.GRASS,    items = {"evergreen", "sapling", "spiderden"},          item_count=10},
            },
            centroid= 	{tile=GROUND.FOREST, 	items={"--cavelight"},			item_count=1},
        },
    },
    contents =  {
        distributepercent = .175,
        distributeprefabs =
        {
            --cavelight = 0.025,

            spiderden = .1,
            rabbithouse = 1,

            fireflies = 1,
            sapling = 15,
            evergreen = .25,
            berrybush = .5,
            blue_mushroom = .5,
            green_mushroom = .3,
            red_mushroom = .4,
            grass = .25,
            cave_fern = 20,
        },
    }
})

---------------------------------------------
-- Fungus Noise
---------------------------------------------

-- Fungus noise
AddRoom("FungusNoiseForest", {
    colour={r=1.0,g=1.0,b=1.0,a=0.9},
    value = GROUND.FUNGUS_NOISE,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .4,
        distributeprefabs=
        {
            mushtree_medium = 6.0,
            mushtree_tall = 6.0,
            mushtree_small = 6.0,
            red_mushroom = 0.5,
            green_mushroom = 0.5,
            blue_mushroom = 0.5,

            flower_cave = 0.2,
            flower_cave_double = 0.1,
            flower_cave_triple = 0.1,

            slurper = 0.001,
        },
    }
})

-- Fungus meadow
AddRoom("FungusNoiseMeadow", {
    colour={r=1.0,g=1.0,b=1.0,a=0.9},
    value = GROUND.FUNGUS_NOISE,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .25,
        distributeprefabs=
        {
            mushtree_medium = 1.0,
            mushtree_tall = 1.0,
            mushtree_small = 1.0,
            red_mushroom = 2.5,
            green_mushroom = 2.5,
            blue_mushroom = 2.5,

            flower_cave = 1.5,
            flower_cave_double = 1.0,
            flower_cave_triple = 1.0,

            slurper = 0.001,
        },
    }
})

---------------------------------------------
-- Sinkhole
---------------------------------------------

-- Sprawling forest
AddRoom("SinkholeForest", {
    colour={r=0.2,g=1,b=0.5,a=0.9},
    value = GROUND.SINKHOLE,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .55,
        distributeprefabs=
        {
            grass = 1,
            sapling = .8,
            evergreen = 6.3,
            fireflies = .1,
            --cavelight = 0.01,
            spiderden = 0.3,
        },
    }
})

-- Patchy Forest
AddRoom("SinkholeCopses", {
    colour={r=0.2,g=1,b=0.5,a=0.9},
    value = GROUND.SINKHOLE,
    tags = {"ForceConnected"},
    contents =  {

        distributepercent = .15,
        distributeprefabs=
        {
            grass = 1,
            sapling = .8,
            evergreen = .3,
            cave_fern = .75,
            berrybush = .2,
            fireflies = .1,
            --cavelight = 0.01,
            spiderden = 0.03,
        },
    }
})

-- Sparse sinkholes
AddRoom("SparseSinkholes", {
    colour={r=0.1,g=0.8,b=0.2,a=0.9},
    value = GROUND.SINKHOLE,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .15,
        distributeprefabs=
        {
            grass = 1,
            sapling = .8,
            evergreen = .3,
            cave_fern = .75,
            fireflies = .1,
            --cavelight = 0.01,
            spiderden = 0.03,
        },
    }
})

-- Oasis
AddRoom("SinkholeOasis", {
    colour={r=0.1,g=0.8,b=0.2,a=0.9},
    value = GROUND.SINKHOLE,
    tags = {"ForceConnected"},
    contents =  {
      
        distributepercent = .15,
        distributeprefabs=
        {
            grass = 1,
            sapling = .8,
            pond = .05,
            stalagmite = 0.02,
            stalagmite_med = 0.007,
            stalagmite_low = 0.003,
            cave_fern = .75,
            berrybush = .2,
            fireflies = .1,
            --cavelight = 0.01,
            spiderden = 0.03,
        },
    }
})

-- Grasslands
AddRoom("GrasslandSinkhole", {
    colour={r=0.1,g=0.8,b=0.2,a=0.9},
    value = GROUND.SINKHOLE,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .05,
        distributeprefabs=
        {
            grass = 2,
            --cavelight = 0.01,
        },
    }
})


AddRoom("BGSinkhole", {
    colour={r=0.1,g=0.8,b=0.2,a=0.9},
    value = GROUND.SINKHOLE,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .15,
        distributeprefabs=
        {
            grass = 1,
            sapling = .8,
            evergreen = .3,
            cave_fern = .75,
            fireflies = .1,
            --cavelight = 0.01,
            spiderden = 0.03,
        },
    }
})

---------------------------------------------
-- Swamp
---------------------------------------------

-- Vast sinkhole swamp
AddRoom("UnderSwamp", {
    colour={r=0.4,g=0.1,b=0.6,a=0.9},
    value = GROUND.MARSH,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .35,
	countprefabs = {
		tentacle_garden = 5,
	    },
        distributeprefabs=
        {
            tentacle = 1,
            reeds = 0.5,
            marsh_bush = 1.5,
            marsh_tree = 0.2,
            spiderden = 0.2,

            --cavelight = 0.01,
        },
    }
})

-- Dark swamp
AddRoom("DarkSwamp", {
    colour={r=0.4,g=0.1,b=0.6,a=0.9},
    value = GROUND.MARSH,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .25,
	countprefabs = {
		tentacle_garden = 5,
	    },
        distributeprefabs=
        {
            tentacle = 0.5,
            reeds = 0.5,
            marsh_bush = 0.5,
            spiderden = 0.02,

        },
    }
})

-- Tentacle mud (noise)
AddRoom("TentacleMud", {
    colour={r=0.4,g=0.1,b=0.6,a=0.9},
    value = GROUND.MARSH,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .25,
        distributeprefabs=
        {
            tentacle = 1,
            marsh_bush = 0.75,
            reeds = 0.75,
            spiderden = 0.05,

            --cavelight = 0.01,
        },
    }
})

-- Tentacle forest (noise)
AddRoom("TentaclesAndTrees", {
    colour={r=0.4,g=0.1,b=0.6,a=0.9},
    value = GROUND.MARSH,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {

        distributepercent = .25,
        distributeprefabs=
        {
            tentacle = 1,
            marsh_bush = 1.5,
            marsh_tree = 1.2,
            spiderden = 0.2,
		reeds =  4,
            --cavelight = 0.01,
        },
    }
})

AddRoom("SpiderUnderMarsh", {
    colour={r=.45,g=.75,b=.45,a=.50},
    value = GROUND.MARSH,
    tags = {"ForceConnected"},
    contents =  {
        distributepercent = .1,
        distributeprefabs=
        {
            evergreen = 1.0,
            tentacle = 2,
            pond_mos = 0.1,
            blue_mushroom = 0.1,
            reeds =  4,
            spiderden=3.15,

            --cavelight = 0.01,

        },
        prefabdata = {
            spiderden = function() if math.random() < 0.2 then
                return { growable={stage=2}}
            else
                return { growable={stage=1}}
            end
        end,
    },
}
                    })

AddRoom("BGUnderSwamp", {
    colour={r=0.4,g=0.1,b=0.6,a=0.9},
    value = GROUND.MARSH,
    tags = {"ForceConnected"},
    type = NODE_TYPE.Room,
    contents =  {
        distributepercent = .35,
        distributeprefabs=
        {
            tentacle = 1,
            reeds = 0.5,
            marsh_bush = 1.5,
            marsh_tree = 0.2,
            spiderden = 0.2,

            --cavelight = 0.01,
        },
    }
})












AddRoom("PitRoom", {
					colour={r=.25,g=.28,b=.25,a=.50},
					value = GROUND.IMPASSABLE,
					tags = {"ForceConnected"},
					type = NODE_TYPE.Room,
					internal_type = NODE_INTERNAL_CONNECTION_TYPE.EdgeCentroid,
					contents = {},
				})


AddRoom("Stairs", { -- This room is used to tag for the next level of caves - it will be removed later
					colour={r=0,g=0,b=0,a=0.9},
					value = GROUND.TILES,
					contents =  {
									countprefabs = {
										cave_stairs = 1,
									},
									distributepercent=0.3,
					                distributeprefabs= {
					                    bat = 0.15,
					                    dropperweb= 0.15,

					                	stalagmite = 0.04,
										stalagmite_med = .04,
										stalagmite_low = .04,


										stalagmite_tall=0.04,
										stalagmite_tall_med=0.04,
										stalagmite_tall_low=0.04,
										
										pillar_ruins = 0.01,
										pillar_stalactite = 0.01,
										fissure = 0.01,
					                }
					            }
					})

